/* this is a UDP sender */

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define MAXBUFSIZE 20000


void HandleMessage(int sockfd,char *buf, int bufsize, char *buf1, 
		   struct sockaddr_in *servaddr, socklen_t socksize) 
{
  fd_set rset;
  struct timeval timeout;
  
  sendto(sockfd, buf, bufsize, 0, (struct sockaddr *) servaddr, socksize);

  FD_ZERO(&rset);
  FD_SET(sockfd, &rset);
  timeout.tv_sec = 0;
  timeout.tv_usec = 1000;
      
  while (select(sockfd+1, &rset, NULL, NULL, &timeout) == 0) 
  {/* timeout, retransmit */
    sendto(sockfd, buf, bufsize, 0, (struct sockaddr *) servaddr, socksize);
    FD_ZERO(&rset);
    FD_SET(sockfd, &rset);
    timeout.tv_sec = 0;
    timeout.tv_usec = 1000;
  }

  recvfrom(sockfd, buf1, 1, 0, NULL, NULL);
}


int main(int argc, char *argv[])
{
  int sockfd, i;
  struct sockaddr_in servaddr;
  char buf[MAXBUFSIZE], buf1;

  if (argc < 3) 
  {
    fprintf(stderr,"USAGE: %s ip_addr port.\n", argv[0]);
    exit(-1);
  }

  memset(&servaddr, 0, sizeof(servaddr));  
  servaddr.sin_family = AF_INET;
  inet_pton(AF_INET, argv[1], &servaddr.sin_addr);
  servaddr.sin_port = htons(atoi(argv[2]));

  if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
  {
    perror("socket");
    exit(-1);
  }

  buf[0] = 'A';
  for (i=0; i< 50; i++) 
  {
    HandleMessage(sockfd,buf,MAXBUFSIZE,&buf1, &servaddr,sizeof(servaddr));
    printf("Got ack i= %d\n", i);

    buf[0]++;
    if (buf[0] == 'Z'+1) 
      buf[0] = 'A';
  }



  sleep(2);
  for (i=0; i<4; i++) 
  {
    buf[0] = '+';
    sendto(sockfd, buf, 1, 0, (struct sockaddr *)&servaddr, 
	   sizeof(servaddr));
    sleep(1);
  }
  
  return 0; 
}












