
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>

#define MAXBUFSIZE 20000

int main(int argc, char *argv[])
{
  int sockfd, count;
  socklen_t len;
  struct sockaddr_in servaddr;
  struct sockaddr_in cliaddr;
  char buf[MAXBUFSIZE];
  FILE *fp;

  if (argc < 2) 
  {
    fprintf(stderr,"USAGE: %s port.\n", argv[0]);
    exit(-1);
  }

  memset(&servaddr, 0, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
  servaddr.sin_port = htons((short)atoi(argv[1]));

  if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
  {
    perror("socket");
    exit(-1);
  }

  if ((bind(sockfd, (struct sockaddr *)&servaddr, sizeof(servaddr)) < 0)) 
  {
    perror("bind");
    exit(-1);
  }

  if ((fp = fopen("outputfile", "w")) == NULL) {
    printf("Can not open 'outputfile'\n");
    exit(-1);
  }

  count = 0;
  while (1) 
  {
    sleep(1); /* Just to slow down the server */
    memset(&cliaddr, 0, sizeof(servaddr));
    len = sizeof (cliaddr);
    recvfrom(sockfd, buf, sizeof(buf), 0, (struct sockaddr *)&cliaddr, &len);
    if (!isupper(buf[0])) 
      exit(0);
    fprintf(fp, "%c\n", buf[0]);

    if(count++ != 25) /* Simulate a lost acknowledgement */
      sendto(sockfd, buf, 1, 0, (struct sockaddr *)&cliaddr, len);
    else
      fflush(fp); /* To ensure that it writes to the output file */
    
  }

  return 0;
}

















